/**
* user:  A1002
* fname: Petar
* lname: Nyagolov
* task:  superstition
* score: 45.0
* date:  2017-11-24 11:44:17.980121
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const unsigned MOD = (1e9) + 7;

struct triple {
    int first,second,third;
    triple(){}
    triple(int a, int b, int c) {
        first=a;
        second=b;
        third=c;
    }
    bool operator <(const triple &a) const {
        if(first==a.first) {
            if(second==a.second) return third<a.third;
            return second<a.second;
        }
        return first<a.first;
    }
};

struct matrix {
    unsigned a[422][422];
    matrix() {
        memset(a,0,sizeof(a));
    }
     
};

int n,m,d,k,x[4444],y[4444],t[4444],sumt;
int cnt;
matrix c;
matrix tmp;
int dp[10][15][15];
vector < pair < int, int > > v[84];
long long ans;
int state[84][10007];

int recurse(int node, int rem, int len) {
    if(len>k) return 0;
    if(len==k) {
        return rem==0 ? 1 : 0;
    }
    long long ans=0;
    if(dp[node][rem][len]!=(-1)) return dp[node][rem][len];
    for(int i=0;i<(int)(v[node].size());i++) {
        ans+=recurse(v[node][i].first,(rem+v[node][i].second)%d,len+v[node][i].second);
    }
    if(rem==0 && len>0) ++ans;

    return dp[node][rem][len]=ans%MOD;
}

int get(int node, int len) {
    if(len==0) return 1;
    if(len<0) return 0;
    if(state[node][len]!=(-1)) return state[node][len];
    long long ans=0;
    for(int i=0;i<(int)(v[node].size());i++) ans+=get(v[node][i].first,len-v[node][i].second);
    return state[node][len]=ans%MOD;
}

int new_node() {
    return ++cnt;
}

void add_edge(int a, int b) {
    c.a[a][b]=1;
}

matrix mult(matrix a, matrix b) {
    int i,j,z;

    for(i=1;i<=cnt;i++) {
        for(j=1;j<=cnt;j++) {
            unsigned long long sum=0;
            for(z=1;z<=cnt;z++) {
                sum+=a.a[i][z]*1ll*b.a[z][j]%MOD;
            }
            tmp.a[i][j]=sum%MOD;
        }
    }

    return tmp;
}

matrix fpow(matrix a, int b) {
    matrix c;
    for(int i=1;i<=cnt;i++) c.a[i][i]=1;

    while(b) {
        if(b&1) c=mult(a,c);
        a=mult(a,a);
        b>>=1;
    }

    return c;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i,j;

    scanf("%d %d %d %d", &n, &m, &d, &k);
    for(i=1;i<=m;i++) {
        scanf("%d %d %d", &x[i], &y[i], &t[i]);
        v[x[i]].push_back(make_pair(y[i],t[i]));
        v[y[i]].push_back(make_pair(x[i],t[i]));
        sumt+=t[i];
    }

    //It's subtask 3
    if(d==k && sumt<=200) {
        cnt=n;
        for(i=1;i<=m;i++) {
            if(t[i]==1) add_edge(y[i],x[i]),add_edge(x[i],y[i]);
            else {
                int last=x[i];
                for(j=1;j<t[i];j++) {
                    int curr=new_node();
                    add_edge(last,curr);
                    last=curr;
                }
                add_edge(last,y[i]);

                swap(x[i],y[i]);
                last=x[i];
                for(j=1;j<t[i];j++) {
                    int curr=new_node();
                    add_edge(last,curr);
                    last=curr;
                }
                add_edge(last,y[i]);

            }
        }
        
        c=fpow(c,k);
        unsigned long long ans=0;
        for(i=1;i<=n;i++) {
            for(j=1;j<=n;j++) {
                ans+=c.a[i][j];
            }
        }

        printf("%llu\n", ans%MOD);

    	return 0;
	}

    //It's subtask 1
    if(n<=5 && m<=5 && d<=12 && k<=12) {
   		memset(dp,-1,sizeof(dp));
        for(i=1;i<=n;i++) {
            ans+=recurse(i,0,0);
    	}

    	printf("%lld\n", ans%MOD);
        
        return 0;
    }

    //It's subtask 2
    if(d<=10000 && k<=10000) {
        memset(state,-1,sizeof(state));
        for(i=1;i<=n;i++) {
            for(j=d;j<=k;j+=d) {
                ans+=get(i,j);
            }
        }
        printf("%lld\n", ans%MOD);

        return 0;
    }

    return 0;
}
