/**
* user:  A1002
* fname: Petar
* lname: Nyagolov
* task:  khans
* score: 70.0
* date:  2017-11-24 10:13:10.172832
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int INF = (1e9) + 7;
const int DCNT = 4;
const pair < int, int > D[DCNT] = {
    make_pair(0,1),
    make_pair(-1,0),
    make_pair(0,-1),
    make_pair(1,0)
};

int n,m,k,a[12][12];
unordered_map < int, int > state[12][12][102];
int pw2[12],pw8[12];
int cnt[4];

int get_code(pair < int, int > a) {
    return a.first-a.second+abs(a.first)+1;
}

int make_relevant(int mask) {
    memset(cnt,0,sizeof(cnt));
    int is=0,i;
    for(i=0;i<7;i++) {
        int curr=mask/pw8[i]%8;
        ++cnt[curr];
        pair < int, int > shift=make_pair(-cnt[3]+cnt[1],-cnt[0]+cnt[2]);
        if(abs(shift.first)+abs(shift.second)+i>7) is|=(1<<i);
    }

    for(i=6;i>=0;i--) if(!(is&(1<<i))) break;

    mask&=((1<<((i+1)*3))-1);
    for(i=i+1;i<7;i++) mask|=(pw8[i]<<2);

    return mask&((1<<((i+1)*3))-1);
}

int recurse(int row, int col, int year, int mask) {
    if(year>k) return 0;
    if(row<0 || row>n || col<0 || col>m) return -INF;
    
    mask=make_relevant(mask);

    if(state[row][col][year].find(mask)!=state[row][col][year].end()) return state[row][col][year][mask];

    int dont[4]={ 0 };
    int i,cnt[4] = { 0, 0, 0, 0 };
    int ans=-INF;

    for(i=0;i<4;i++) {
        int curr=(mask>>(3*i))&7;
        ++cnt[curr];

        pair < int, int > shift=make_pair(-cnt[3]+cnt[1],-cnt[0]+cnt[2]);

        if(abs(shift.first)+abs(shift.second)==1) dont[get_code(shift)]=1;
    }

    for(;i<7;i++) {
        int curr=(mask>>(3*i))&7;
        ++cnt[curr];

        pair < int, int > shift=make_pair(-cnt[3]+cnt[1],-cnt[0]+cnt[2]);
        pair < int, int > cell=make_pair(row+shift.first,col+shift.second);

        if(abs(shift.first)+abs(shift.second)==1) if(pw2[i]<a[cell.first][cell.second]) dont[get_code(shift)]=1;
    }


    for(i=0;i<DCNT;i++) if(dont[get_code(D[i])]==0) {
        ans=max(ans,a[row][col]+recurse(row+D[i].first,col+D[i].second,year+1,((mask<<3)+i)&((1<<21)-1)));
    }

    return state[row][col][year][mask]=ans;
}

int recurse2(int row, int col, int year, int mask) {
    if(year>k) return 0;
    if(row<0 || row>n || col<0 || col>m) return -INF;
    
    if(state[row][col][year].find(mask)!=state[row][col][year].end()) return state[row][col][year][mask];

    int dont[4]={ 0 };
    int i,cnt[4] = { 0, 0, 0, 0 };
    int ans=-INF;

    for(i=0;i<4;i++) {
        int curr=(mask>>(3*i))&7;
        ++cnt[curr];

        pair < int, int > shift=make_pair(-cnt[3]+cnt[1],-cnt[0]+cnt[2]);

        if(abs(shift.first)+abs(shift.second)==1) dont[get_code(shift)]=1;
    }

    for(;i<7;i++) {
        int curr=(mask>>(3*i))&7;
        ++cnt[curr];

        pair < int, int > shift=make_pair(-cnt[3]+cnt[1],-cnt[0]+cnt[2]);
        pair < int, int > cell=make_pair(row+shift.first,col+shift.second);

        if(abs(shift.first)+abs(shift.second)==1) if(pw2[i]<a[cell.first][cell.second]) dont[get_code(shift)]=1;
    }


    for(i=0;i<DCNT;i++) if(dont[get_code(D[i])]==0) {
        ans=max(ans,a[row][col]+recurse2(row+D[i].first,col+D[i].second,year+1,((mask<<3)+i)&((1<<21)-1)));
    }

    return state[row][col][year][mask]=ans;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i,j;

    pw2[0]=pw8[0]=1;
    for(i=1;i<=10;i++) pw2[i]=pw2[i-1]*2,pw8[i]=pw8[i-1]*8;

    scanf("%d %d %d", &n, &m, &k);
    for(i=1;i<=n;i++) {
        for(j=1;j<=m;j++) {
            scanf("%d", &a[i][j]);
        }
    }

    if((n<=5 && m<=5) || k<=25) printf("%d\n", recurse2(1,1,1,0));
    else printf("%d\n", recurse(1,1,1,0));

    fprintf(stderr, "Time: %d ms\n", (int)(clock()*1000.0/CLOCKS_PER_SEC));

    return 0;
}
