/**
* user:  A1002
* fname: Petar
* lname: Nyagolov
* task:  khans
* score: 15.0
* date:  2017-11-24 08:02:36.150907
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

int n,m,k,a[12][12];
map < deque < pair < char, char > >, short > dp[12][12][102];
int pw[12];

short recurse(int row, int col, int year, deque < pair < char, char > > d) {
    if(year>k) return 0;
    while(!d.empty() && pw[d.size()]>=a[d.front().first][d.front().second]) d.pop_front();

    if(dp[row][col][year].find(d)!=dp[row][col][year].end()) return dp[row][col][year][d];

    bool can0=(col>1),can1=(row>1),can2=(col<m),can3=(row<n);
    int ans=0;

    int i;
    for(i=0;i<(int)(d.size());i++) {
        if(d[i].first==row && d[i].second==col-1) {
            if(pw[d.size()-i]<a[row][col-1]) can0=false;
        }
        else if(d[i].first==row-1 && d[i].second==col) {
            if(pw[d.size()-i]<a[row-1][col]) can1=false;
        }
        else if(d[i].first==row && d[i].second==col+1) {
            if(pw[d.size()-i]<a[row][col+1]) can2=false;
        }
        else if(d[i].first==row+1 && d[i].second==col) {
            if(pw[d.size()-i]<a[row+1][col]) can3=false;
        }
    }

    d.push_back(make_pair(row,col));

    //Left
    if(can0) {
        ans=max(ans,recurse(row,col-1,year+1,d)+a[row][col]);
    }

    //Up
    if(can1) {
        ans=max(ans,recurse(row-1,col,year+1,d)+a[row][col]);
    }

    //Right
    if(can2) {
        ans=max(ans,recurse(row,col+1,year+1,d)+a[row][col]);
    }

    //Down
    if(can3) {
        ans=max(ans,recurse(row+1,col,year+1,d)+a[row][col]);
    }

    return dp[row][col][year][d]=ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i,j;
    deque < pair < char, char > > d;

    pw[0]=1;
    for(i=1;i<=10;i++) pw[i]=pw[i-1]*2;

    scanf("%d %d %d", &n, &m, &k);
    for(i=1;i<=n;i++) {
        for(j=1;j<=m;j++) {
            scanf("%d", &a[i][j]);
        }
    }

    printf("%d\n", (int)(recurse(1,1,1,d)));

    return 0;
}
