/**
* user:  A1003
* fname: Radoslav
* lname: Dimitrov
* task:  khans
* score: 50.0
* date:  2017-11-24 08:14:26.879613
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T2> void chkmax(T &x, const T2 &y) { if(x < y) x = y; }
template<class T, class T2> void chkmin(T &x, const T2 &y) { if(x > y) x = y; }
const int MAXN = (11);

int n, m, k;
vector<vector<int> >  a;

void read()
{
    cin >> n >> m >> k;
    a.assign(n, vector<int>(m, 0));
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            cin >> a[i][j];
}

/*
map<vector<vector<int> >, int> dp[11][11][101];

vector<vector<int> > get_next(vector<vector<int> > &t)
{
    vector<vector<int> > ret;
    ret.assign(n, vector<int>(m, 0));
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            ret[i][j] = min(a[i][j], t[i][j] * 2);

    return ret;
}

int rec(int x, int y, vector<vector<int> > &tbl, int ck)
{
    if(ck == k) return 0;

    if(dp[x][y][ck].count(tbl)) return dp[x][y][ck][tbl];
    int &memo = dp[x][y][ck][tbl];
    memo = -1e9;

    vector<vector<int> > nxt = get_next(tbl);
    nxt[x][y] = 1;

    for(int dx = -1; dx < 2; dx++)
        for(int dy = -1; dy < 2; dy++)
            if((dx + dy) == 1 || (dx + dy) == -1)
            {
                int nx = dx + x;
                int ny = dy + y;
                if(nx < 0 || ny < 0 || nx >= n || ny >= m) continue;
                if(nxt[nx][ny] != a[nx][ny]) continue;
                memo = max(memo, rec(nx, ny, nxt, ck + 1) + a[x][y]);
            }

    return memo;
}
*/

uint64_t get_hash(vector<int> &last)
{
    uint64_t ret = 0;
    for(int x: last)
        ret = ret * 12ull + x;

    return ret;
}

int get_value(vector<int> &last, int x, int y)
{
    for(int i = 1, pos = last.size() - 1; pos >= 0; pos -= 2)
    {
        int cy = last[pos], cx = last[pos - 1];
        int v = min(a[cx][cy], i);
        if(cx == x && cy == y)
            return v;

        i = i * 2;
    }

    return a[x][y];
}

map<uint64_t, int> dp[11][11][101];

int rec(int x, int y, vector<int> &last, int ck)
{
    if(ck == k) return 0;

    uint64_t h = get_hash(last);

    if(dp[x][y][ck].count(h)) return dp[x][y][ck][h];
    int &memo = dp[x][y][ck][h];
    memo = -1e9;

    vector<int> nxt = last;
    nxt.push_back(x);
    nxt.push_back(y);
    if(nxt.size() > 14)
    {
        nxt.erase(nxt.begin());
        nxt.erase(nxt.begin());
    }

    for(int dx = -1; dx < 2; dx++)
        for(int dy = -1; dy < 2; dy++)
            if((dx + dy) == 1 || (dx + dy) == -1)
            {
                int nx = dx + x;
                int ny = dy + y;
                if(nx < 0 || ny < 0 || nx >= n || ny >= m) continue;
                if(get_value(last, nx, ny) != a[nx][ny]) continue;
                memo = max(memo, rec(nx, ny, nxt, ck + 1) + a[x][y]);
            }

    return memo;
}

void solve()
{
    vector<int> beg(0, 0);
    cout << rec(0, 0, beg, 0) << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}
