/**
* user:  A1003
* fname: Radoslav
* lname: Dimitrov
* task:  superstition
* score: 35.0
* date:  2017-11-24 10:01:07.151867
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T2> void chkmax(T &x, const T2 &y) { if(x < y) x = y; }
template<class T, class T2> void chkmin(T &x, const T2 &y) { if(x > y) x = y; }
const int MAXN = (82);
const int mod = (int)1e9 + 7;

int n, m, d, k;
int G[MAXN][MAXN];
int maxt;

void read()
{
    cin >> n >> m >> d >> k;
    for(int i = 0; i < m; i++)
    {
        int u, v, t;
        cin >> u >> v >> t;

        G[u][v] = t;
        G[v][u] = t;
    }
}

int dp[MAXN][10042];

int rec(int u, int T)
{
    if(T > k) return 0;

    int &memo = dp[u][T];
    if(memo != -1)
        return memo;

    memo = (T % d == 0);
    for(int v = 1; v <= n; v++)
        if(G[u][v] != 0)
            memo = (memo + rec(v, T + G[u][v])) % mod;

    return memo;
}

void solve()
{
    if(k <= 10000)
    {
        memset(dp, -1, sizeof(dp));

        int answer = mod - n;
        for(int i = 1; i <= n; i++)
            answer = (answer + rec(i, 0)) % mod;

        cout << answer << endl;
        return;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}
