/**
* user:  A1003
* fname: Radoslav
* lname: Dimitrov
* task:  khans
* score: 100.0
* date:  2017-11-24 11:09:39.879421
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T2> void chkmax(T &x, const T2 &y) { if(x < y) x = y; }
template<class T, class T2> void chkmin(T &x, const T2 &y) { if(x > y) x = y; }
const int MAXN = (11);

int n, m, k;
vector<vector<int> >  a;

void read()
{
    cin >> n >> m >> k;
    a.assign(n, vector<int>(m, 0));
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            cin >> a[i][j];
}

/*
map<vector<vector<int> >, int> dp[11][11][101];

vector<vector<int> > get_next(vector<vector<int> > &t)
{
    vector<vector<int> > ret;
    ret.assign(n, vector<int>(m, 0));
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            ret[i][j] = min(a[i][j], t[i][j] * 2);

    return ret;
}

int rec(int x, int y, vector<vector<int> > &tbl, int ck)
{
    if(ck == k) return 0;

    if(dp[x][y][ck].count(tbl)) return dp[x][y][ck][tbl];
    int &memo = dp[x][y][ck][tbl];
    memo = -1e9;

    vector<vector<int> > nxt = get_next(tbl);
    nxt[x][y] = 1;

    for(int dx = -1; dx < 2; dx++)
        for(int dy = -1; dy < 2; dy++)
            if((dx + dy) == 1 || (dx + dy) == -1)
            {
                int nx = dx + x;
                int ny = dy + y;
                if(nx < 0 || ny < 0 || nx >= n || ny >= m) continue;
                if(nxt[nx][ny] != a[nx][ny]) continue;
                memo = max(memo, rec(nx, ny, nxt, ck + 1) + a[x][y]);
            }

    return memo;
}
*/

int dir_x[4] = {0, 0, -1, 1};
int dir_y[4] = {1, -1, 0, 0};

vector<int16_t> dp[MAXN][MAXN][8][2];

/*
int rec(int x, int y, uint64_t last, int ck)
{
    if(ck == k) return 0;

    if(dp[x][y][ck].count(last)) return dp[x][y][ck][last];
    int &memo = dp[x][y][ck][last];
    memo = 0;

    uint64_t nxt = last;

    if(nxt > (pw11[12]))
        nxt %= pw11[12];

    nxt = nxt * 11ull + (int64_t)x + 1;
    nxt = nxt * 11ull + (int64_t)y + 1;

    for(int dx = -1; dx < 2; dx++)
        for(int dy = -1; dy < 2; dy++)
            if((dx + dy) == 1 || (dx + dy) == -1)
            {
                int nx = dx + x;
                int ny = dy + y;
                if(nx < 0 || ny < 0 || nx >= n || ny >= m) continue;
                if(get_value(last, nx, ny) == a[nx][ny]) memo = max(memo, rec(nx, ny, nxt, ck + 1) + a[x][y]);
            }

    return memo;
}*/

/*
vector<int8_t> adj[MAXN][MAXN][1 << 14];
*/

int get_value(int i, int j, int mask, int len, int nx, int ny)
{
    int pw2 = 1;
    for(int p = 0; p < len; p++)
    {
        int cdir = (mask & 3);

        i -= dir_x[cdir];
        j -= dir_y[cdir];

        if(nx == i && ny == j)
            return min(a[i][j], pw2);

        mask >>= 2;
        pw2 *= 2;
    }

    return a[nx][ny];
}

void solve()
{
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            for(int len = 0; len < 8; len++)
                for(int fl = 0; fl < 2; fl++)
                    dp[i][j][len][fl].assign((1 << (2 * len)), -2e4);

    dp[0][0][0][0][0] = 0;
    for(int K = 0; K < k; K++)
    {
        for(int i = 0; i < n; i++)
            for(int j = 0; j < m; j++)
                for(int len = 0; len < 8; len++)
                    for(int mask = 0; mask < (1 << (2 * len)); mask++)
                        dp[i][j][len][(K & 1) ^ 1][mask] = -2e4;

        int c = K & 1;
        for(int i = 0; i < n; i++)
            for(int j = 0; j < m; j++)
                for(int len = 0; len < 8; len++)
                    for(int mask = 0; mask < (1 << (2 * len)); mask++)
                    {
                        int16_t &memo = dp[i][j][len][c][mask];
                        if(memo < 0) continue;

                        int nxt_len = min(7, len + 1);

                        for(int d = 0; d < 4; d++)
                        {
                            int nx = i + dir_x[d];
                            int ny = j + dir_y[d];

                            if(nx < 0 || ny < 0 || nx >= n || ny >= m) continue;

                            if(get_value(i, j, mask, len, nx, ny) == a[nx][ny])
                            {
                                int nmask = (mask << 2) | d;
                                nmask %= (1 << 14);
                                chkmax(dp[nx][ny][nxt_len][c ^ 1][nmask], a[i][j] + memo);
                            }
                        }

                    }
    }

    int answer = 0;
    for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            for(int len = 0; len < 8; len++)
                for(int mask = 0; mask < (1 << (2 * len)); mask++)
                {
                    //cout << i << " " << j << " " << len << " " << mask << " -> " << dp[i][j][len][k & 1][mask] << endl;
                    chkmax(answer, dp[i][j][len][k & 1][mask]);
                }

    cout << answer << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}
