/**
* user:  A1004
* fname: Viktor
* lname: Terziev
* task:  superstition
* score: 35.0
* date:  2017-11-24 11:52:28.180825
*/
#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int n, m, k, d;
vector < pair < int, int > > neigh[100];
long long cntW[100][20042], mod = 1000000007;

int main () {
    cin >> n >> m >> d >> k;
    for ( int i= 0 ; i < m ; i ++ ) {
        int a, b, t;
        cin >> a >> b >> t;
        neigh[a].push_back( make_pair( b, t ) );
        neigh[b].push_back( make_pair( a, t ) );
    }

    for ( int i = 1 ; i <= n ; i ++ ) {
        cntW[i][0] = 1;
    }
    long long ans = 0;

    for ( int w = 0 ; w <= k ; w ++ ) {
        for ( int i = 1 ; i <= n ; i ++ ) {
            if ( w && w %d == 0 ) {
                ans += cntW[i][w];
                if ( ans >= mod ) { ans -= mod; }
            }

            for ( int j = 0 ; j < neigh[i].size() ; j ++ ) {
                cntW[ neigh[i][j].first ][ w + neigh[i][j].second ] += cntW[i][w];
                if ( cntW[ neigh[i][j].first ][ w + neigh[i][j].second ] >= mod ) {
                    cntW[ neigh[i][j].first ][ w + neigh[i][j].second ] -= mod;
                }
            }

        }
    }
    cout << ans <<  "\n";

    return 0;
}
/*
3 3 2 2
1 2 1
2 3 2
3 1 1
*/
