/**
* user:  A1006
* fname: Ilia
* lname: Bozhinov
* task:  khans
* score: 20.0
* date:  2017-11-24 10:20:45.199821
*/
#include <iostream>
#include <chrono>
#include <cstdlib>

#define debug(x) #x << " = " << (x)
#define _ << " " << 

const int maxn = 12;
int n, m;
int age[maxn][maxn];
int t[maxn][maxn];
int max = 0;

int glsum = 0, k;

bool ok(int i, int j, int time)
{
    int d = time - age[i][j];
    if (d > 20) return true;
    if (d < 1) return false;
    if ((1 << (d - 1) >= t[i][j]))
            return true;
           
            return false;
}

using pii = std::pair<int, int>;
int p = 0;
pii path[maxn];

long long start;

void rec(int i, int j, int time = 0, int sum = 0)
{
    auto now = std::chrono::system_clock::now().time_since_epoch().count();
    if ((now - start) * 1. / 1e9 >= 0.96)
    {
        std::cout << glsum << "\n";
        std::exit(0);
    }

 //   std::cout << i _ j << std::endl;
    if (sum + k * max <= glsum || !ok(i, j, time))
        return;

    if (time == k)
    {
        glsum = std::max(glsum, sum);
        return;
    }

    int was = age[i][j];
    age[i][j] = time;

    for (int dx = -1; dx <= 1; dx++)
    {
        for (int dy = -1; dy <= 1; dy++)
        {

            if (dy * dx != 0 || (dx == dy && dx == 0)) continue;

            int x = i + dx, y = j + dy;
            if (0 > x || 0 > y || x >= n || y >= m) continue;

            rec(x, y, time + 1, sum + t[i][j]);
        }
    }
    age[i][j] = was;
}

int main()
{
    start = std::chrono::system_clock::now().time_since_epoch().count();
    std::cin >> n >> m >> k;

    for (int i = 0; i< n; i++) for (int j = 0; j < m; j++) std::cin >> t[i][j], max = std::max(max, t[i][j]), age[i][j] = -100;

    rec(0, 0);
    std::cout << glsum << std::endl;

    return 0;
}
