/**
* user:  A1006
* fname: Ilia
* lname: Bozhinov
* task:  superstition
* score: 5.0
* date:  2017-11-24 08:00:39.292040
*/
#include <iostream>

#define _ << " " <<
#define debug(x) #x << " = " << (x)

using ll = long long;

const int mmm = 100;
int dp[90][90][mmm];

int gm(int x)
{
    return (x % mmm + mmm) % mmm;
}

#include <map>
#include <vector>

#define X first
#define Y second
using pii = std::pair<int, int>;

std::vector<pii> v[90];
const int mod = 1000000007;


int main()
{
    std::ios::sync_with_stdio(false);

    int n, m, d, k;
    std::cin >>n >> m >> d >> k;

    for (int i = 0; i < m; i++)
    {
        int x, y, w;
        std::cin >> x >> y >> w;

        v[x].push_back({y, w});
        v[y].push_back({x, w});
    }

    for (int i = 1; i <= n; i++) dp[i][i][0] = 1;


    ll sum = 0;
    for (int rt = 1; rt <= k; rt++)
    {
        int t = gm(rt);
        for (int i = 1; i <= n; i++)
        {
            for (int j = i; j <= n; j++)
            {
                for (auto e : v[j])
                {
                    if (e.Y > t) continue;
                    dp[i][j][t] += dp[i][e.X][gm(t - e.Y)];
                    dp[i][j][t] %= mod;
                }

             //   std::cout << debug(i) _ debug(j) _ debug(t) _ debug(dp[i][j][t]) << std::endl;

                if (t % d == 0)
                {
                    sum += (dp[i][j][t] + (i != j) * dp[i][j][t]) % mod;
                    sum %= mod;
                }


                dp[j][i][t] = dp[i][j][t];
            }
        }
    }

    std::cout << sum << std::endl;
}
