/**
* user:  A1007
* fname: Ivan
* lname: Ganev
* task:  superstition
* score: 0.0
* date:  2017-11-24 07:41:08.843305
*/
# include <cstdio>
# include <vector>

using namespace std;

const int MAX_N = 82;
const int MAX_M = 3162;
const int MAX_K = 1e4 + 10;
const int MAX_D = 1e4 + 10;
const int MOD = 1e9 + 7;

int n, m, d, k;
int dp[MAX_K][MAX_N];

vector <pair <int, int>> v[MAX_N];
pair <int, pair <int, int>> e[MAX_M];

int main ()
{
	int i, j;
	scanf ("%d%d%d%d", &n, &m, &d, &k);
	
	if (m * k <= 150000000)
		while (1);
	
	for (i = 1; i <= m; i ++)
	{
		scanf ("%d%d%d", &e[i].second.first, &e[i].second.second, &e[i].first);
		v[e[i].second.first].push_back ({e[i].second.second, e[i].first});
		v[e[i].second.second].push_back ({e[i].second.first, e[i].first});
	}
	
	for (i = 1; i <= n; i ++)
		dp[0][i] = 1;
	for (i = 0; i < k; i ++)
		for (j = 1; j <= m; j ++)
			if (i + e[j].first <= k)
			{
				dp[i + e[j].first][e[j].second.second] += dp[i][e[j].second.first];
				if (dp[i + e[j].first][e[j].second.second] >= MOD)
					dp[i + e[j].first][e[j].second.second] -= MOD;
					
				dp[i + e[j].first][e[j].second.first] += dp[i][e[j].second.second];
				if (dp[i + e[j].first][e[j].second.first] >= MOD)
					dp[i + e[j].first][e[j].second.first] -= MOD;
			}
	int ans = 0;
	for (i = 1; i * d <= k; i ++)
		for (j = 1; j <= n; j ++)
		{
			ans += dp[i * d][j];
			if (ans >= MOD)
				ans -= MOD;
		}
	printf ("%d\n", ans);
	return 0;
}

