/**
* user:  A1008
* fname: Radostin
* lname: Chonev
* task:  superstition
* score: 35.0
* date:  2017-11-24 09:09:58.097317
*/
#include<iostream>
#include<stdio.h>
#include<vector>
using namespace std ;

#define MOD 1000000007

int n , m , d , k ;
vector < pair < int , int > > v[ 87 ] ;
long long dp[ 87 ][ 10017 ] ;

void input ( ) {
	scanf ( "%d%d%d%d" , &n , &m , &d , &k ) ;
	int i ;
	for ( i = 1 ; i <= m ; i ++ ) {
		int x , y , z ;
		scanf ( "%d%d%d" , &x , &y , &z ) ;
		v[ x ].push_back ( make_pair ( y , z ) ) ;
		v[ y ].push_back ( make_pair ( x , z ) ) ;
	} 
}

void solve ( ) {
	int i , j , t ;
	for ( i = 1 ; i <= n ; i ++ ) {
		dp[ i ][ 0 ] = 1 ;
	}
	for ( j = 0 ; j < k ; j ++ ) {
		for ( i = 1 ; i <= n ; i ++ ) {
			if ( dp[ i ][ j ] == 0 ) { continue ; }
			int sz = v[ i ].size ( ) ;
			for ( t = 0 ; t < sz ; t ++ ) {
				dp[ v[ i ][ t ].first ][ j + v[ i ][ t ].second ] += dp[ i ][ j ] ;
				dp[ v[ i ][ t ].first ][ j + v[ i ][ t ].second ] %= MOD ;
			}
		}
	}
	long long ans = 0 ;
	for ( i = d ; i <= k ; i += d ) {
		for ( j = 1 ; j <= n ; j ++ ) {
			ans += dp[ j ][ i ] ;
			ans %= MOD ;
		}
	}
	printf ( "%lld\n" , ans ) ;
}

int main ( ) {
	input ( ) ;
	solve ( ) ;
	return 0 ;
}
