/**
* user:  A1010
* fname: Plamen
* lname: Dinev
* task:  khans
* score: 40.0
* date:  2017-11-24 11:32:53.196140
*/
#include <iostream>
#include <vector>
#include <ctime>
#include <cstdint>
#include <utility>
#include <algorithm>
using namespace std;

uint8_t log2u32 (uint32_t a)
{
    return ((uint8_t)(sizeof(a)<<3)-
            (uint8_t)1-(uint8_t)__builtin_clz(a));
}

uint8_t time_to_regenerate (uint8_t a)
{
    uint8_t res=log2u32(a);
    if(a!=((uint8_t)1<<res))res++;
    res+=2;
    return res;
}


uint8_t n, m, k;
uint8_t field_food[10][10];
uint8_t field_last_used[10][10]; ///may be uint32_t
uint8_t field_time_to_regenerate[10][10];

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    {
        uint16_t nx, mx, kx;
        cin>>nx>>mx>>kx;
        n=nx;m=mx;k=kx;
    }
    for(uint8_t i=0; i<n; i++)
        for(uint8_t j=0; j<m; j++)
        {
            uint16_t x;
            cin>>x;
            field_food[i][j]=x;
            field_time_to_regenerate[i][j]=time_to_regenerate(x);
            field_last_used[i][j]=UINT8_MAX;
        }


}

void show_food ()
{
    for(uint8_t i=0; i<n; i++)
    {
        for(uint8_t j=0; j<m; j++)
            cout<<(short)field_food[i][j]<<' ';
        cout<<endl;
    }
}

void show_time_to_regenerate ()
{
    for(uint8_t i=0; i<n; i++)
    {
        for(uint8_t j=0; j<m; j++)
            cout<<(short)field_time_to_regenerate[i][j]<<' ';
        cout<<endl;
    }
}

void show_last_used ()
{
    for(uint8_t i=0; i<n; i++)
    {
        for(uint8_t j=0; j<m; j++)
            cout<<(short)field_last_used[i][j]<<' ';
        cout<<endl;
    }
}

bool it_s_time_to_stop=false;

uint32_t rec (uint8_t x=0, uint8_t y=0, uint8_t year=1)
{
    if(clock()>1000000UL)it_s_time_to_stop=true;
    if(it_s_time_to_stop)return field_food[x][y];
    //if(field_last_used[x][y]!=UINT8_MAX&&field_last_used[x][y]+field_time_to_regenerate[x][y]>year){cout<<"FAK"<<endl;return 0;}
    //cout<<(short)x<<' '<<(short)y<<' '<<(short)year<<endl;
    if(year==k)return field_food[x][y];
    uint32_t res=0, tmp=field_last_used[x][y];
    field_last_used[x][y]=year;
    vector < pair < uint8_t, pair < uint8_t, uint8_t> > > v;
    v.reserve(4);
    if(x<n-1&&!(field_last_used[x+1][y]!=UINT8_MAX&&field_last_used[x+1][y]+field_time_to_regenerate[x+1][y]>year+1))
        v.push_back(make_pair(field_food[x+1][y], make_pair(x+1, y)));
    if(x>0  &&!(field_last_used[x-1][y]!=UINT8_MAX&&field_last_used[x-1][y]+field_time_to_regenerate[x-1][y]>year+1))
        v.push_back(make_pair(field_food[x-1][y], make_pair(x-1, y)));
    if(y<m-1&&!(field_last_used[x][y+1]!=UINT8_MAX&&field_last_used[x][y+1]+field_time_to_regenerate[x][y+1]>year+1))
        v.push_back(make_pair(field_food[x][y+1], make_pair(x, y+1)));
    if(y>0  &&!(field_last_used[x][y-1]!=UINT8_MAX&&field_last_used[x][y-1]+field_time_to_regenerate[x][y-1]>year+1))
        v.push_back(make_pair(field_food[x][y-1], make_pair(x, y-1)));
    //cout<<"ASD: "<<v.size()<<endl;
    sort(v.begin(), v.end());
    reverse(v.begin(), v.end());
    for(auto p: v)
    {
        res=max(res,rec(p.second.first, p.second.second, year+1));
        if(it_s_time_to_stop)return field_food[x][y]+res;
    }

    /*
    if(x<n-1)
    {
        res=max(res,rec(x+1, y, year+1));
    }
    if(x>0)
    {
        res=max(res, rec(x-1, y, year+1));
    }
    if(y<m-1)
    {
        res=max(res, rec(x, y+1, year+1));
    }
    if(y>0)
    {
        res=max(res, rec(x, y-1, year+1));
    }
    */

    field_last_used[x][y]=tmp;
    if(res==0)return 0;
    res+=field_food[x][y];
    return res;
}

int main()
{
    init();
    //cout<<"------------------------\n";
    //show_food();
    //cout<<"------------------------\n";
    //show_time_to_regenerate();
    //cout<<"------------------------\n";
    //show_last_used();
    //cout<<"------------------------\n";
    cout<<rec()<<endl;
    //cout<<"------------------------\n";
    //show_last_used();



    return 0;
}
