/**
* user:  A1021
* fname: Ivailo
* lname: Georgiev
* task:  khans
* score: 25.0
* date:  2017-11-24 11:45:34.429184
*/
#include <iostream>
#include <cstdio>
using namespace std;
const int MAX_N = 16;
const int MAX_M = 16;
int N, M, K;
int a[MAX_N][MAX_M], log[MAX_N][MAX_M], lastv[MAX_N][MAX_M];
int find_log(int x)
{
    int ret = 0;
    while(x > 0)
    {
        x /= 2;
        ++ ret;
    }
    return ret;
}
int dfs(int x, int y, int st, int sum)
{
    if(st == K)   return (sum + a[x][y]);
    int dab, sq = 0, curr;
    if(x - 1 > 0 && (st + 1 - lastv[x - 1][y] >= log[x - 1][y] || lastv[x - 1][y] == 0))
    {
        dab = lastv[x - 1][y];
        lastv[x - 1][y] = st + 1;
        curr = dfs(x - 1, y, st + 1, sum + a[x][y]);
        lastv[x - 1][y] = dab;
        sq = max(sq, curr);
    }
    if(y - 1 > 0 && (st + 1 - lastv[x][y - 1] >= log[x][y - 1] || lastv[x][y - 1] == 0))
    {
        dab = lastv[x][y - 1];
        lastv[x][y - 1] = st + 1;
        curr = dfs(x, y - 1, st + 1, sum + a[x][y]);
        lastv[x][y - 1] = dab;
        sq = max(sq, curr);
    }
    if(x + 1 <= N && (st + 1 - lastv[x + 1][y] >= log[x + 1][y] || lastv[x + 1][y] == 0))
    {
        dab = lastv[x + 1][y];
        lastv[x + 1][y] = st + 1;
        curr = dfs(x + 1, y, st + 1, sum + a[x][y]);
        lastv[x + 1][y] = dab;
        sq = max(sq, curr);
    }
    if(y + 1 <= M && (st + 1 - lastv[x][y + 1] >= log[x][y + 1] || lastv[x][y + 1] == 0))
    {
        dab = lastv[x][y + 1];
        lastv[x][y + 1] = st + 1;
        curr = dfs(x, y + 1, st + 1, sum + a[x][y]);
        lastv[x][y + 1] = dab;
        sq = max(sq, curr);
    }
    return sq;
}
bool step(int x)
{
    int curr = 1;
    while(1)
    {
        if(curr == x)   return true;
        else if(curr > x)   return false;
        curr *= 2;
    }
}
int main()
{
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    int sb = 0;
    cin >> N >> M >> K;
    for(int i = 1; i <= N; ++ i)
    {
        for(int j = 1; j <= M; ++ j)
        {
            cin >> a[i][j];
            sb += a[i][j];
            if(step(a[i][j]))   log[i][j] = find_log(a[i][j]) + 1;
            else   log[i][j] = find_log(a[i][j]) + 2;
        }
    }
    int ans;
    lastv[1][1] = 1;
    if(K <= 20)   ans = dfs(1, 1, 1, 0);
    else
    {
        int curr = K / 20;
        ans = curr * sb;
        K %= 20;
        ans += dfs(1, 1, 1, 0);
    }
    cout << ans << "\n";
    return 0;
}
/**
4 4 11
11 17 13 96
10 12 18 15
13 12 16 17
24 10 14 22
**/
