/**
* user:  A1030
* fname: Kamen
* lname: Hristov
* task:  superstition
* score: 35.0
* date:  2017-11-24 08:41:23.229357
*/
#include<iostream>
#include<vector>
#define MOD 1000000007
using namespace std;

struct edge
{
    long long n;
    long long w;

    edge() {};

    edge(int _n, long long _w)
    {
        n= _n;
        w= _w;
    }
};

long long n, m, d, k;
vector<edge> neigh[128];
long long state[128][16384];

long long solveState(long long g, long long tmpk)
{
    if(tmpk > k) return 0;
    if(state[g][tmpk]) return state[g][tmpk];

    int i;
    for(i=0; i<neigh[g].size(); i++)
    {
        state[g][tmpk] = (state[g][tmpk] + solveState(neigh[g][i].n, tmpk+neigh[g][i].w)) % MOD;
    }

    return state[g][tmpk];
}

int main()
{
    long long i, y, g1, g2, w, ans=0;

    cin>>n>>m>>d>>k;
    for(i=0; i<m; i++)
    {
        cin>>g1>>g2>>w;
        g1--; g2--;
        neigh[g1].push_back(edge(g2, w));
        neigh[g2].push_back(edge(g1, w));
    }

    for(i=0; i<n; i++)
    {
        state[i][k]=1;
    }


    for(i=1; i*d<=k; i++)
    {
        for(y=0; y<n; y++)
        {
            ans = (ans+ solveState(y, k-i*d)) % MOD;
        }
    }

    cout<<ans<<endl;
}
