/**
* user:  A1002
* fname: Petar
* lname: Nyagolov
* task:  superstition
* score: 0.0
* date:  2017-11-24 10:29:37.357344
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MOD = (1e9) + 7;

struct triple {
    int first,second,third;
    triple(){}
    triple(int a, int b, int c) {
        first=a;
        second=b;
        third=c;
    }
    bool operator <(const triple &a) const {
        if(first==a.first) {
            if(second==a.second) return third<a.third;
            return second<a.second;
        }
        return first<a.first;
    }
};

int n,m,d,k;
map < triple, int > dp;
vector < pair < int, int > > v[84];
long long ans;

int recurse(int node, int rem, int len) {
    if(len>k) return 0;
    if(len==k) {
        return rem==0 ? 1 : 0;
    }
    long long ans=0;
    if(dp.find(triple(node,rem,len))!=dp.end()) return dp[triple(node,rem,len)];
    for(int i=0;i<(int)(v[node].size());i++) {
        ans+=recurse(v[node][i].first,(rem+v[node][i].second)%d,rem+v[node][i].second);
    }
    if(rem==0 && len>0) ++ans;

    return dp[triple(node,rem,len)]=ans%MOD;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i,x,y,z;

    scanf("%d %d %d %d", &n, &m, &d, &k);
    for(i=1;i<=m;i++) {
        scanf("%d %d %d", &x, &y, &z);
        v[x].push_back(make_pair(y,z));
        v[y].push_back(make_pair(x,z));
    }
    
    for(i=1;i<=n;i++) {
        ans+=recurse(i,0,0);
    }

    printf("%lld\n", ans%MOD);

    return 0;
}
