/**
* user:  A1002
* fname: Petar
* lname: Nyagolov
* task:  superstition
* score: 10.0
* date:  2017-11-24 11:19:53.539734
*/
#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const unsigned MOD = (1e9) + 7;

struct matrix {
    unsigned a[422][422];
    matrix() {
        memset(a,0,sizeof(a));
    }
     
};

int n,m,d,k,x[4444],y[4444],t[4444],sumt;
int cnt;
matrix c;
matrix tmp;

int new_node() {
    return ++cnt;
}

void add_edge(int a, int b) {
    c.a[a][b]=1;
}

matrix mult(matrix a, matrix b) {
    int i,j,z;

    for(i=1;i<=cnt;i++) {
        for(j=1;j<=cnt;j++) {
            unsigned long long sum=0;
            for(z=1;z<=cnt;z++) {
                sum+=a.a[i][z]*1ll*b.a[z][j]%MOD;
            }
            tmp.a[i][j]=sum%MOD;
        }
    }

    return tmp;
}

matrix fpow(matrix a, int b) {
    matrix c;
    for(int i=1;i<=cnt;i++) c.a[i][i]=1;

    while(b) {
        if(b&1) c=mult(a,c);
        a=mult(a,a);
        b>>=1;
    }

    return c;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int i,j;

    scanf("%d %d %d %d", &n, &m, &d, &k);
    for(i=1;i<=m;i++) {
        scanf("%d %d %d", &x[i], &y[i], &t[i]);
        sumt+=t[i];
    }

    //It's subtask 4
    if(d==k && sumt<=200) {
        cnt=n;
        for(i=1;i<=m;i++) {
            if(t[i]==1) add_edge(y[i],x[i]),add_edge(x[i],y[i]);
            else {
                int last=x[i];
                for(j=1;j<t[i];j++) {
                    int curr=new_node();
                    add_edge(last,curr);
                    last=curr;
                }
                add_edge(last,y[i]);

                swap(x[i],y[i]);
                last=x[i];
                for(j=1;j<t[i];j++) {
                    int curr=new_node();
                    add_edge(last,curr);
                    last=curr;
                }
                add_edge(last,y[i]);

            }
        }
        
        c=fpow(c,k);
        unsigned long long ans=0;
        for(i=1;i<=n;i++) {
            for(j=1;j<=n;j++) {
                ans+=c.a[i][j];
            }
        }

        printf("%llu\n", ans%MOD);
    }

    return 0;
}
