/**
* user:  A1004
* fname: Viktor
* lname: Terziev
* task:  khans
* score: 40.0
* date:  2017-11-24 10:57:44.373327
*/
#include <iostream>
#include <unordered_map>
using namespace std;
int n, m, k, arr[16][16];

unordered_map< int, int > mem[16][16][152];
unordered_map< int, int > used[16][16][152];

int gmax ( int cx, int cy, int kl, int mask ) {

    mask %= (1<<16);

    if ( kl == 0 ) { return 0; }

    if ( used[cx][cy][kl].count(mask) ) { return mem[cx][cy][kl][mask]; }
    used[cx][cy][kl][mask] = 1;

    int ret = 0;

    bool able[16][16];
    for ( int i = 0 ; i < n ; i ++ ) {
        for ( int j = 0 ; j < m ; j ++ ) {
            able[i][j] = 1;
        }
    }
    int cp = mask;
    int x = cx, y = cy;

 //   cout << cp << ": ";

    for ( int cc = 0; cc < 10 && cc < k-kl ; cc ++ ) {
        int d = cp%4;
        cp /= 4;

        if ( d == 0 ) { x--; }
        if ( d == 1 ) { y --; }
        if ( d == 2 ) { x ++; }
        if ( d == 3 ) {y ++; }
//        cout << x<< " "<< y << "\n";

        if ( x < 0 || y < 0 || x == m || y == n ) { break; }

        if ( (1<<cc) < arr[y][x] ) { able[y][x] = 0; }
    }

    if ( cx +1 < m && able[cy][cx+1] ) { /// 0
        int nx = cx+1, ny = cy;
        ret = max( ret, gmax( nx, ny, kl-1, (mask*4+0) ) );
    }
    if ( cy+1 < n && able[cy+1][cx] ) { /// 1
        int nx = cx, ny = cy+1;
        ret = max( ret, gmax( nx, ny, kl-1, (mask*4+1) ) );

    }
    if ( cx -1 >= 0 && able[cy][cx-1]) { /// 2
        int nx = cx-1, ny = cy;
        ret = max( ret, gmax( nx, ny, kl-1, (mask*4+2) ) );

    }
    if ( cy -1 >= 0 && able[cy-1][cx] ) { ///3
        int nx = cx, ny = cy-1;
        ret = max( ret, gmax( nx, ny, kl-1, (mask*4+3) ) );

    }

    ret += arr[cy][cx];
    mem[cx][cy][kl][mask] = ret;
    return ret;
}

int main () {
    cin >> n >> m >> k;
    for ( int i = 0 ; i < n ; i ++ ) {
        for ( int j = 0 ; j < m ; j ++ ) {
            cin >> arr[i][j];
        }
    }


    cout << gmax( 0, 0, k, 0 ) << "\n";
    return 0;
}

/*
4 4 11
11 17 13 96
10 12 18 15
13 12 16 17
24 10 14 22
*/
