/**
* user:  A1007
* fname: Ivan
* lname: Ganev
* task:  khans
* score: 20.0
* date:  2017-11-24 11:52:52.215639
*/
# include <cstdio>
# include <set>
# include <map>
# include <algorithm>

using namespace std;

const int MAX_N = 12;
const int MAX_M = 12;
const int MAX_K = 105;
const int STATE = 3 * 3 * 3 * 3 * 3;

int n, m, mk;
int a[MAX_N][MAX_M];
int b[MAX_N][MAX_M];
map <int, int> dp[MAX_N][MAX_M][MAX_K];

int aa[4] = {-1, 1, 0, 0};
int bb[4] = {0, 0, -1, 1};

int go (int x, int y, int k, int st)
{
	if (dp[x][y][k][st])
		return dp[x][y][k][st];
	if (k == mk - 1)
		return dp[x][y][k][st] = a[x][y];
	dp[x][y][k][st] = -(1 << 30);
	set <pair <int, int>> s;
	int px = x, py = y, t = min (5, k), c, nx, ny, i;
	for (i = 0; i < t; i ++)
	{
		c = (st >> (2 * i)) & 3;
		if (c == 0)
			px ++;
		if (c == 1)
			px --;
		if (c == 2)
			py ++;
		if (c == 3)
			py --;
		if (b[px][py] > (i + 1)) 
			s.insert ({px, py});
	}
	for (i = 0; i < 4; i ++)
	{
		nx = x + aa[i];
		ny = y + bb[i];
		if (nx < 0 || nx >= n)
			continue;
		if (ny < 0 || ny >= m)
			continue;
		if (s.find ({nx, ny}) != s.end ())
			continue;
		dp[x][y][k][st] = max (dp[x][y][k][st], a[x][y] + go (nx, ny, k + 1, ((st & ((1 << 9) - 1)) << 2) + i));
	}
	
	return dp[x][y][k][st];
}

int main ()
{
	int i, j, cb;
	scanf ("%d%d%d", &n, &m, &mk);
	for (i = 0; i < n; i ++)
		for (j = 0; j < m; j ++)
		{
			scanf ("%d", &a[i][j]);
			for (cb = 1; (1 << (cb - 1)) < a[i][j]; cb ++);
			b[i][j] = cb;
		}
		
	printf ("%d\n", go (0, 0, 0, 0));
			
	return 0;
}

