/**
* user:  A1007
* fname: Ivan
* lname: Ganev
* task:  khans
* score: 25.0
* date:  2017-11-24 08:49:03.719950
*/
# include <cstdio>
# include <ctime>
# include <cstdlib>
# include <map>
# include <algorithm>

using namespace std;

const int MAX_N = 11;
const int MAX_M = 11;
const int MAX_K = 111;

int n, m, k;
int a[MAX_N][MAX_M];
int l[MAX_N][MAX_M];
int b[MAX_N][MAX_M];
int ans;

int aa[4] = {-1, 1, 0, 0};
int bb[4] = {0, 0, -1, 1};

inline bool check ()
{
	return (clock () > 0.95 * CLOCKS_PER_SEC);
}

void go (int ck, int x, int y, int s)
{
	///printf ("%d %d %d %d\n", ck, x, y, s);
	l[x][y] = ck;
	if (ck == k)
	{
		if (s > ans)
			ans = s;
		return;
	}
	if (check ())
	{
		printf ("%d\n", ans);
		exit (0);
	}
	int p, i, j;
	if (rand () & 4)
	{
		int cnt;
		for (cnt = 0; cnt < 8; cnt ++)
		{
			p = rand () % 4;
			if ((x + aa[p] < 1) || (x + aa[p] > n))
				continue;
			if ((y + bb[p] < 1) || (y + bb[p] > m))
				continue;
			if ((ck + 1 - l[x + aa[p]][y + bb[p]]) >= b[x + aa[p]][y + bb[p]])
				break;
		}
		if (cnt < 8)
		{
		
			int fl[MAX_N][MAX_N];
			for (i = 1; i <= n; i ++)
				for (j = 1; j <= m; j ++)
					fl[i][j] = l[i][j];
			go (ck + 1, x + aa[p], y + bb[p], s + a[x + aa[p]][y + bb[p]]);
			
			for (i = 1; i <= n; i ++)
				for (j = 1; j <= m; j ++)
					l[i][j] = fl[i][j];
		}
	}
	int pp = -1, qq = 0;
	for (i = 0; i < 4; i ++)
	{
		if ((x + aa[i] < 1) || (x + aa[i] > n))
			continue;
		if ((y + bb[i] < 1) || (y + bb[i] > m))
			continue;
		if ((ck + 1 - l[x + aa[i]][y + bb[i]]) >= b[x + aa[i]][y + bb[i]])
		{
			if (qq < a[x + aa[i]][y + bb[i]])
				qq = a[x + aa[i]][y + bb[i]], pp = i;
		}
	}
	if (pp != -1)
		go (ck + 1, x + aa[pp], y + bb[pp], s + a[x + aa[pp]][y + bb[pp]]);
}

int h[MAX_N][MAX_M];
int prv[MAX_N][MAX_M][22];
int cs;

void t20 (int x, int y, int ck)
{
	cs += a[x][y];
	prv[x][y][ck] = h[x][y];
	h[x][y] = ck;
	///printf ("%d %d %d %d\n", ck, x, y, cs);
	if (ck == k)
	{
		if (cs > ans)
			ans = cs;
	}
	else
	{
		int i, nx, ny;
		for (i = 0; i < 4; i ++)
		{
			nx = x + aa[i];
			ny = y + bb[i];
			if (nx < 1 || nx > n)
				continue;
			if (ny < 1 || ny > m)
				continue;
			if ((ck + 1 - h[nx][ny]) >= b[nx][ny])
				t20 (nx, ny, ck + 1);
		}
	}
	h[x][y] = prv[x][y][ck];
	cs -= a[x][y];
}

int main ()
{
	int i, j, cb;
	scanf ("%d%d%d", &n, &m, &k);
	for (i = 1; i <= n; i ++)
		for (j = 1; j <= m; j ++)
			h[i][j] = -10;
	for (i = 1; i <= n; i ++)
		for (j = 1; j <= m; j ++)
		{
			scanf ("%d", &a[i][j]);
			l[i][j] = -10;
			for (cb = 1; (1 << (cb - 1)) < a[i][j]; cb ++);
			b[i][j] = cb;
			h[i][j] = -10;
			///printf ("%d %d %d\n", i, j, b[i][j]);
		}
	
	if (k <= 18)
	{
		t20 (1, 1, 1);
		printf ("%d\n", ans);
		return 0;
	}
	
	/**
	i = 1;
	j = i;
	i --;
	printf ("%d\n", j / i);
	**/
	go (1, 1, 1, a[1][1]);
	printf ("%d\n", ans);
	return 0;
}

