/**
* user:  A1010
* fname: Plamen
* lname: Dinev
* task:  superstition
* score: 5.0
* date:  2017-11-24 09:05:53.669377
*/
#include <iostream>
#include <cstdint>
#include <vector>
#include <algorithm>
#include <unordered_map>
using namespace std;

uint32_t d, k;
vector < vector < pair< uint8_t, uint8_t > > > ss;

#define MOD 1000000007

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    uint16_t n, m;
    cin>>n>>m>>d>>k;
    ss.resize(n);
    for(uint16_t i=0; i<m; i++)
    {
        uint16_t u, v, t;
        cin>>u>>v>>t;
        u--;v--;
        ss[u].push_back(make_pair<uint8_t, uint8_t>(v, t));
        ss[v].push_back(make_pair<uint8_t, uint8_t>(u, t));
    }
}

void show()
{
    for(uint8_t i=0; i<ss.size(); i++)
    {
        cout<<(short)i+1<<": ";
        for(uint8_t j=0; j<ss[i].size(); j++)
            cout<<"{"<<(short)ss[i][j].first+1<<", "<<(short)ss[i][j].second<<"} ";
        cout<<endl;
    }
}

unordered_map<uint32_t, uint32_t> mem[80];

uint32_t rec(uint8_t cur, uint32_t time_used=0)
{
    if(time_used>k)return 0;
    if(mem[cur].count(time_used))return mem[cur][time_used];
    uint32_t res=0;
    if(time_used>0&&time_used%d==0)res++;
    for(uint8_t i=0; i<ss[cur].size(); i++)
    {
        uint16_t v=ss[cur][i].first, v_t=ss[cur][i].second;
        if(time_used+v_t<=k)
        {
            res+=rec(v, time_used+v_t);
            if(res>MOD)res-=MOD;
        }
    }
    return mem[cur][time_used]=res;
}

int main()
{
    init();
    //show();
    uint32_t res=0;
    for(uint8_t i=0; i<ss.size(); i++)
    {
        res+=rec(i);
        if(res>MOD)res-=MOD;
    }
    cout<<res<<endl;

    return 0;
}
