/**
* user:  A1016
* fname: Yoana
* lname: Zelova
* task:  superstition
* score: 35.0
* date:  2017-11-24 09:16:04.636803
*/
#include<bits/stdc++.h>
using namespace std;
vector<vector<pair<long long, long long>>> neighbours;
vector<vector<long long>> ans;

const long long MOD=1000000007;
int main()
{
    long long n,m,d,k;
    cin>>n>>m>>d>>k;

    neighbours.resize(n+10);
    ans.resize(n+10, vector<long long>(k+10));
    for(long long i=1; i<=m; i++)
    {
        long long x,y,t;
        cin>>x>>y>>t;
        neighbours[x].push_back({y,t});
        neighbours[y].push_back({x,t});
    }
    for(long long i=1;i<=n;i++)
        ans[i][0]=1;
    for(long long t=1; t<=k; t++)
    {
        for(long long i=1; i<=n; i++)
        {
            for(pair<long long, long long> p : neighbours[i])
            {
                if(p.second<=t)ans[i][t]=((ans[i][t]%MOD)+(ans[p.first][t-p.second]%MOD))%MOD;
            }
        }
    }
    long long answer=0;
    for(long long i=1; d*i<=k; i++)
    {
        for(long long j=1; j<=n; j++)
        {
            answer=((answer%MOD)+(ans[j][d*i]%MOD))%MOD;
        }
    }
    cout<<answer<<endl;
    return 0;
}
/*
5 7 5 10
1 3 8
2 5 7
3 4 3
1 4 2
2 3 1
1 5 4
4 5 4

5 9 2 20
1 2 1
2 3 2
3 1 1
3 4 1
4 5 2
5 3 1
1 5 1
2 4 1
2 5 1
*/
