/**
* user:  A1019
* fname: Vasilena
* lname: Cvetanova
* task:  khans
* score: 0.0
* date:  2017-11-24 11:30:05.720589
*/
#include<bits/stdc++.h>
const int MAXN=20;
using namespace std;

deque<int> a[MAXN][MAXN];
deque<int> temp[MAXN][MAXN];
vector<pair<int, int>> day[MAXN];
deque<int> pr;
deque<int> best;
int n, m, d;

deque<int> add(deque<int> a, deque<int> b)
{
    if(a.size()<b.size()) swap(a, b);
    int carry=0;
    int i=b.size()-1, j=a.size()-1;
    for(; i>=0&&j>=0; i--, j--)
    {
        a[j]=b[i]+a[j]+carry;
        carry=a[j]/10;
        a[j]%=10;
    }

    while(carry!=0&&j>=0)
    {
        a[j]+=carry;
        carry=a[j]/10;
        a[j]%=10;
        j--;
    }

    while(carry!=0)
    {
        a.push_front(carry%10);
        carry/=10;
    }

    return a;
}

bool cmp(deque<int> a, deque<int> b)
{
    if(a.size()<b.size()) return true;
    if(a.size()>b.size()) return false;
    for(int i=0; i<a.size(); i++) if(a[i]>b[i]) return false;

    return true;
}
deque<int> rem(deque<int> a, deque<int> b)
{
    if(cmp(a, b)) swap(a, b);
    int carry=0;
    int i=b.size()-1, j=a.size()-1;
    for(; i>=0&&j>=0; i--, j--)
    {
        a[j]=a[j]-b[i]-carry;
        carry=0;
        if(a[j]<0) {carry=1, a[j]+=10;}
    }
    while(carry!=0&&j>=0)
    {
        a[j]-=carry;
        carry=0;
        if(a[j]<0) {carry=1, a[j]+=10;}
        j--;
    }
    while(a.size()>=2&&a[0]==0) a.pop_front();

    return a;
}

deque<int> c;
deque<int> del(deque<int> &aa)
{
    c.clear();
    int temp=0;
    for(int i=0; i<aa.size(); i++)
    {
        temp+=aa[i];
        if(temp==1&&i<aa.size()) {i++; temp*=10; temp+=aa[i];}
        c.push_back(temp/2);
        temp=0;
        if(temp%2==1) temp=10;
    }

    return c;
}

bool ok(int x, int y) {return x<n&&y<m&&x>=0&&y>=0;}

void recurse(int x, int y, int s)
{
    deque<int> last=temp[x][y];
    pr=add(pr, a[x][y]);
    temp[x][y].clear(); temp[x][y].push_back(0);

    if(cmp(best, pr)) best=pr;

    day[s+1].push_back({x, y});

    for(int i=0; i<n; i++)
        for(int j=0; j<m; j++) temp[i][j]=add(temp[i][j], temp[i][j]);

    for(int i=0; i<day[s].size(); i++) {temp[day[s][i].first][day[s][i].second].clear(); temp[day[s][i].first][day[s][i].second].push_back(1);}

    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            for(int k=0; k<temp[i][j].size(); k++) cout<<temp[i][j][k];
            cout<<" ";
        }
        cout<<endl;
    }
    cout<<endl;
    if(s==d)
    {
        for(int i=0; i<day[s].size(); i++) {temp[day[s][i].first][day[s][i].second].clear(); temp[day[s][i].first][day[s][i].second].push_back(0);}

        for(int i=0; i<n; i++)
            for(int j=0; j<m; j++) temp[i][j]=del(temp[i][j]);

        day[s].clear();
        day[s+1].clear();
        temp[x][y]=last;
        pr=rem(a[x][y], pr);
        return;
    }

    if(ok(x, y+1)&&cmp(a[x][y+1], temp[x][y+1])) recurse(x, y+1, s+1);
    if(ok(x, y-1)&&cmp(a[x][y-1], temp[x][y-1])) recurse(x, y-1, s+1);
    if(ok(x+1, y)&&cmp(a[x+1][y], temp[x+1][y])) recurse(x+1, y, s+1);
    if(ok(x-1, y)&&cmp(a[x-1][y], temp[x-1][y])) recurse(x-1, y, s+1);

    for(int i=0; i<day[s].size(); i++) {temp[day[s][i].first][day[s][i].second].clear(); temp[day[s][i].first][day[s][i].second].push_back(0);}

    for(int i=0; i<n; i++)
        for(int j=0; j<m; j++) temp[i][j]=del(temp[i][j]);

    day[s].clear();
    day[s+1].clear();
    temp[x][y]=last;
    pr=rem(a[x][y], pr);
}
void mainp()
{
    pr.push_back(0);
    best.push_back(0);
    cin>>n>>m>>d;
    for(int i=0; i<n; i++)
        for(int j=0; j<m; j++)
        {
            int el;
            cin>>el;
            if(el==100)
            {
                a[i][j].push_back(1);
                a[i][j].push_back(0);
                a[i][j].push_back(0);
            }
            else
            {
                a[i][j].push_back(el/10);
                a[i][j].push_back(el%10);
            }
            temp[i][j]=a[i][j];
        }

    recurse(0, 0, 1);
    for(int i=0; i<best.size(); i++) cout<<best[i];


/*    deque<int> a, b;
    a.push_back(1);
    a.push_back(2);
    b=a;
    for(int i=0; i<b.size(); i++) cout<<b[i]<<" ";
    cout<<endl;
    deque<int> c, a, b;
    a.push_back(5);
    a.push_back(1);
    a.push_back(4);
    b.push_back(2);
    c=del(a);
    for(int i=0; i<c.size(); i++) cout<<c[i];*/
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    mainp();
}

