/**
* user:  A1020
* fname: Emil
* lname: Indzhev
* task:  khans
* score: 10.0
* date:  2017-11-24 11:57:18.796112
*/
#include<iostream>
#include<queue>
#include<map>
#include<stdlib.h>
#include<algorithm>
#include<stack>
#include<vector>
#include<unordered_map>
#include<math.h>
using namespace std;

const int MAX_N=10;
const int max_K=100;
const int TTE=8748;
int n,m,k;
int a[MAX_N][MAX_N];
int vis[MAX_N][MAX_N][TTE+10][2];
char steps[MAX_N][MAX_N];
int answer;
struct Pos
{
    int xy;
    int k_came;
    int food;
};

void input()
{
    cin>>n>>m>>k;
    for (int i=0; i<n; ++i)
    {
        for (int j=0; j<m; ++j)
        {
            cin>>a[i][j];
        }
    }
}

void output()
{
    cout<<answer<<endl;
}
queue<Pos> q[2];
bool curr=0;
Pos pos;
int my_log(int a)
{
    int ans=1;
    int a2=1;
    while (a2<a)
    {
        a2*=2;
        ++ans;
    }
    return ans;
}
void preprocess()
{
    for (int i=0; i<n; ++i)
    {
        for (int j=0; j<m; ++j)
        {
            steps[i][j]=my_log(a[i][j]);
        }
    }
}
bool blocked[4];
void move(int& x, int& y, int dir)
{
    if (dir==0) --x;
    if (dir==1) ++y;
    if (dir==2) ++x;
    if (dir==3) --y;
}
void find_blocked(int came[], int last, int xc, int yc, int year)
{
    for (int i=0; i<4; ++i)
        blocked[i]=0;

    int x=0,y=0;
    int dir=last;
    move(x,y,dir);
    for (int i=0; i<min(7,year); ++i)
    {
        if (((x==1 || x==-1) && y==0) || ((y==1 || y==-1) && x==0))
        {
            if (xc+x>=0 && xc+x<n && yc+y>=0 && yc+y<m)
            {
                if (i<steps[xc+x][yc+y])
                {
                    if (x==-1) blocked[0]=1;
                    if (y==1) blocked[1]=1;
                    if (x==1) blocked[2]=1;
                    if (y==-1) blocked[3]=1;
                }
            }
        }
        if (came[i]!=1) dir+=came[i]+1;
        dir%=4;
        move(x,y,dir);
    }
    if (((x==1 || x==-1) && y==0) || ((y==1 || y==-1) && x==0))
    {
        if (xc+x>=0 && xc+x<n && yc+y>=0 && yc+y<m)
        {
            if (7<steps[xc+x][yc+y])
            {
                if (x==-1) blocked[0]=1;
                if (y==1) blocked[1]=1;
                if (x==1) blocked[2]=1;
                if (y==-1) blocked[3]=1;
            }
        }
    }
}
int maxfood=0;
bool show=0;
void process_pos(Pos& pos)
{
    int year;
    int y=pos.xy%20;
    int x=pos.xy/20;
    int newfood;
    if (show) cerr<<x<<" "<<y<<" "<<pos.k_came<<endl;
    int came[7],last;
    last=pos.k_came%4;
    pos.k_came/=4;
    if (show) cerr<<" "<<last;
    for (int i=0; i<7; ++i)
    {
        came[i]=pos.k_came%3;
        pos.k_came/=3;
        if (show) cerr<<" "<<came[i];
    }
    year=pos.k_came;
    if (show) cerr<<"  "<<year<<endl;
    int new_k_came=year+1,new_came=0,curr_came=came[6];
    for (int i=5; i>=0; --i)
    {
        new_came*=3;
        new_came+=came[i];
        curr_came*=3;
        curr_came+=came[i];
        new_k_came*=3;
        new_k_came+=came[i];
    }
    new_k_came*=3;
    new_came*=3;
    curr_came*=4;
    curr_came+=last;
    //cerr<<curr_came<<endl;
    int food=max(vis[x][y][curr_came][curr],pos.food);
    //cerr<<"F: "<<food<<endl;
    if (year==k-1)
    {
        if (food>maxfood) maxfood=food;
        return;
    }
    int new_came2=new_came;
    if (show) cerr<<" "<<new_came<<endl;
    find_blocked(came,last,x,y,year);
    for (int i=0;i<4;++i)
    {
        if (show) cerr<<blocked[i]<<endl;
    }
    Pos new_pos;
    if (x>0 && blocked[0]==0)
    {
        if (show) cerr<<"checking 0"<<endl;
        new_pos.xy=(x-1)*20+y;
        new_pos.k_came=(new_k_came+(4+2-last+1)%4)*4+2;
        new_came=(new_came2+(4+2+last+1)%4)*4+2;
        //cerr<<new_came<<endl;
        newfood=food+a[x-1][y];
        new_pos.food=newfood;
        if (vis[x-1][y][new_came][!curr]==-1)
        {
            vis[x-1][y][new_came][!curr]=newfood;
            q[!curr].push(new_pos);
        }
        else if (vis[x-1][y][new_came][!curr]<newfood) vis[x-1][y][new_came][!curr]=newfood;
        if (show) cerr<<"checked 0"<<endl;

    }
    if (y<m-1 && blocked[1]==0)
    {
        if (show) cerr<<"checking 1"<<endl;
        new_pos.xy=(x)*20+y+1;
        new_pos.k_came=(new_k_came+(4+3-last+1)%4)*4+3;
        new_came=(new_came2+(4+3+last+1)%4)*4+3;
        //cerr<<new_came<<endl;
        newfood=food+a[x][y+1];
        new_pos.food=newfood;
        if (vis[x][y+1][new_came][!curr]==-1)
        {
            vis[x][y+1][new_came][!curr]=newfood;
            q[!curr].push(new_pos);
        }
        else if (vis[x][y+1][new_came][!curr]<newfood) vis[x-1][y][new_came][!curr]=newfood;
        if (show) cerr<<"checked 1"<<endl;
    }
    if (x<n-1 && blocked[2]==0)
    {
        if (show) cerr<<"checking 2"<<endl;
        new_pos.xy=(x+1)*20+y;
        new_pos.k_came=(new_k_came+(4+0-last+1)%4)*4+0;
        new_came=(new_came2+(4+0+last+1)%4)*4+0;
        //cerr<<new_came<<endl;
        newfood=food+a[x+1][y];
        new_pos.food=newfood;
        if (vis[x+1][y][new_came][!curr]==-1)
        {
            vis[x+1][y][new_came][!curr]=newfood;
            q[!curr].push(new_pos);
        }
        else if (vis[x+1][y][new_came][!curr]<newfood) vis[x-1][y][new_came][!curr]=newfood;
        if (show) cerr<<"checked 2"<<endl;
    }
    if (y>0 && blocked[3]==0)
    {
        if (show) cerr<<"checking 3"<<endl;
        new_pos.xy=(x)*20+y-1;
        new_pos.k_came=(new_k_came+(4+1-last+1)%4)*4+1;
        new_came=(new_came2+(4+1+last+1)%4)*4+1;
        //cerr<<new_came<<endl;
        newfood=food+a[x][y-1];
        new_pos.food=newfood;
        if (vis[x][y-1][new_came][!curr]==-1)
        {
            vis[x][y-1][new_came][!curr]=newfood;
            q[!curr].push(new_pos);
        }
        else if (vis[x][y-1][new_came][!curr]<newfood)
        {
            vis[x][y-1][new_came][!curr]=newfood;
        }
        if (show) cerr<<"checked 3"<<endl;
    }
}
void step()
{
    for (int i=0; i<n; ++i)
    {
        for (int j=0; j<m; ++j)
        {
            for (int k=0; k<=TTE; ++k)
            {
                vis[i][j][k][!curr]=-1;
            }
        }
    }
    //cerr<<q[curr].size()<<endl;
    int count=0;
    while (!q[curr].empty())
    {
        //cerr<<count++<<endl;
        //cerr<<" here!"<<endl;
        pos=q[curr].front();
        q[curr].pop();
        process_pos(pos);
    }
    curr=!curr;
}

void solve()
{
    if (k==1)
    {
        maxfood=a[0][0];
        return;
    }
    preprocess();
    vis[0][0][0][curr]=a[0][0];
    q[curr].push({0,0,a[0][0]});
    while (!q[curr].empty())
    {
        //cerr<<"Hi!"<<endl;
        step();
    }
    answer=maxfood;
}

int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    //cerr<<my_log(100)<<" "<<my_log(4)<<" "<<my_log(5)<<endl;

    input();
    solve();
    output();

    return 0;
}
