/**
* user:  A1021
* fname: Ivailo
* lname: Georgiev
* task:  superstition
* score: 5.0
* date:  2017-11-24 11:52:39.099343
*/
#include <iostream>
#include <cstdio>
#include <vector>
using namespace std;
const int MOD = 1e9 + 7;
const int MAX_N = 128;
int N, M, D, K;
struct edge
{
    int to;
    int st;
    edge(){}
    edge(int _to, int _st)
    {
        to = _to;
        st = _st;
    }
};
vector <edge> v[MAX_N];
int ans;
void dfs(int vr, int curr)
{
    if(curr >= D && curr % D == 0)
    {
        ++ ans;
        if(ans == MOD)   ans = 0;
    }
    if(curr == K)   return;
    int sz = v[vr].size();
    for(int i = 0; i < sz; ++ i)
    {
        int ne = v[vr][i].to, nest = v[vr][i].st;
        if(curr + nest <= K)   dfs(ne, curr + nest);
    }
}
int main()
{
    int a, b, c;
    scanf("%d %d %d %d", &N, &M, &D, &K);
    for(int i = 1; i <= M; ++ i)
    {
        scanf("%d %d %d", &a, &b, &c);
        v[a].push_back(edge(b, c));
        v[b].push_back(edge(a, c));
    }
    for(int i = 1; i <= N; ++ i)   dfs(i, 0);
    printf("%d\n", ans);
    return 0;
}
