/**
* user:  A1024
* fname: Yordan
* lname: Dimitrov
* task:  superstition
* score: 5.0
* date:  2017-11-24 09:29:50.121356
*/
#include<bits/stdc++.h>
#define MOD 1000000007
#define MAX_N 82
using namespace std;
int n, m, k, d, ans, currsum;
struct edge
{
    int from, to, weight;
    edge() {};
    edge(int from_, int to_, int weight_)
    {
        from=from_;
        to=to_;
        weight=weight_;
    }
};
vector<pair<int, int> > v[MAX_N];
vector<edge> e;
void read()
{
    scanf("%d %d %d %d", &n, &m, &d, &k);
    int x, y, z;
    for(int i=1; i<=m; i++)
    {
        scanf("%d %d %d", &x, &y, &z);
        v[x].push_back(make_pair(y, z));
        v[y].push_back(make_pair(x, z));
        e.push_back(edge(x, y, z));
        e.push_back(edge(y, x, z));
    }
}
void DFS(int u)
{
    if(currsum>k)
        return;
    if(currsum%d==0)
        ans++;
    int sz=v[u].size();
    for(int i=0; i<sz; i++)
    {
        currsum+=v[u][i].second;
        DFS(v[u][i].first);
        currsum-=v[u][i].second;
    }
}
void solve()
{
    for(int i=0; i<m*2; i++)
    {
        currsum+=e[i].weight;
        DFS(e[i].to);
        //cerr<<i<<' '<<ans<<endl;
        currsum-=e[i].weight;
    }
    printf("%d\n", ans);
}
int main()
{
    freopen("input.txt", "r", stdin);
    read();
    solve();
	return 0;
}