/**
* user:  A1025
* fname: Dimitar
* lname: Oparlakov
* task:  superstition
* score: 35.0
* date:  2017-11-24 10:55:56.671308
*/
#include <iostream>
#include <cstdio>
using namespace std;

#define NMax 80
#define MMax 3160
#define TMax 10

struct edge
{
    long long v1,v2,tg;
} edges[MMax+5];

long long n,m,d,k,ans;
long long know[NMax+2][10001];
const long long Mod=1000000007LL;

int main()
{
    scanf("%lld%lld%lld%lld",&n,&m,&d,&k);

    for(long long i=0;i<m;i++)
    {
        scanf("%lld%lld%lld",&edges[i].v1,&edges[i].v2,&edges[i].tg);
    }

    for(long long i=1;i<=n;i++)
        know[i][0]=1;

    for(long long i=1;i<=k;i++)
    {
        for(long long j=0;j<m;j++)
        {
            if(i>=edges[j].tg)
            {
                know[edges[j].v1][i]+=know[edges[j].v2][i-edges[j].tg];
                know[edges[j].v2][i]+=know[edges[j].v1][i-edges[j].tg];
                know[edges[j].v1][i]%=Mod;
                know[edges[j].v2][i]%=Mod;
            }
        }
    }

    for(long long i=d;i<=k;i+=d)
        for(long long j=1;j<=n;j++)
        {
            ans+=know[j][i];
            ans%=Mod;
        }

        cout<<ans%Mod<<endl;
    return 0;
}
/**
3 3 2 2
1 2 1
2 3 2
3 1 1
*/
