/**
* user:  A1030
* fname: Kamen
* lname: Hristov
* task:  superstition
* score: 35.0
* date:  2017-11-24 08:51:07.820745
*/
#include<iostream>
#include<vector>
#define MOD 1000000007
using namespace std;

struct edge
{
    int n;
    int w;

    edge() {};

    edge(int _n, int _w)
    {
        n= _n;
        w= _w;
    }
};

int n, m, d, k;
vector<edge> neigh[128];
int state[128][16384];

int solveState(int g, int tmpk)
{
    if(tmpk > k) return 0;
    if(state[g][tmpk]) return state[g][tmpk];

    int i;
    for(i=0; i<neigh[g].size(); i++)
    {
        state[g][tmpk] = (state[g][tmpk] + solveState(neigh[g][i].n, tmpk+neigh[g][i].w)) % MOD;
    }

    return state[g][tmpk];
}

void cases1and2()
{
    int i, y, ans=0;

    for(i=0; i<n; i++)
    {
        state[i][k]=1;
    }


    for(i=1; i*d<=k; i++)
    {
        for(y=0; y<n; y++)
        {
            ans = (ans+ solveState(y, k-i*d)) % MOD;
        }
    }

    cout<<ans<<endl;
}

int main()
{
    int i, g1, g2, w;

    cin>>n>>m>>d>>k;
    for(i=0; i<m; i++)
    {
        cin>>g1>>g2>>w;
        g1--; g2--;
        neigh[g1].push_back(edge(g2, w));
        neigh[g2].push_back(edge(g1, w));
    }

    if(d<=10000 && k<=10000)
    {
        cases1and2();
        return 0;
    }

    /**
    for(i=0; i<n; i++)
    {
        state[i][k]=1;
    }


    for(i=1; i*d<=k; i++)
    {
        for(y=0; y<n; y++)
        {
            ans = (ans+ solveState(y, k-i*d)) % MOD;
        }
    }

    cout<<ans<<endl;
    */
    return 0;
}
