/**
* user:  A1033
* fname: Antani
* lname: Gospodinov
* task:  superstition
* score: 5.0
* date:  2017-11-24 11:28:14.831087
*/
#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <ctime>
#define mp make_pair
#define pb push_back
using namespace std;
const int N=86;
const int K=1e4+5;
const int MOD=1e9+7;

int n,m,d,k;
struct edge{

  int v;
  int t;

  edge() {}
  edge(int _v,int _t)
  {
      v=_v;
      t=_t;
  }
};
vector <edge> nb[N];

long long dp[N][K];
long long new_dp[N][K];

void transfer()
{
    int i,j;
    for(i=1;i<=n;i++)
    {
        for(j=1;j<=k;j++)
        {
            dp[i][j]=new_dp[i][j];
            new_dp[i][j]=0;
        }
    }
}

void update_DP()
{
   int i,j,z;
   int v,t;

   for(i=1;i<=n;i++)
   {
       for(j=0;j<nb[i].size();j++)
       {
           v=nb[i][j].v;
           t=nb[i][j].t;
           for(z=t;z<=k;z++)
           {
               new_dp[i][z]=(new_dp[i][z]+dp[v][z-t])%MOD;
           }
       }
   }
}

long long ans;

int main()
{
   int i,j;
   int x,y,t;
   int g;

   scanf("%d%d%d%d", &n, &m, &d, &k);
   g=__gcd(d,k);
   for(i=1;i<=m;i++)
   {
       scanf("%d%d%d", &x, &y, &t);

       g=__gcd(g,t);

       nb[x].pb(edge(y,t));
       nb[y].pb(edge(x,t));
   }

   if(d > k)
   {
       cout<<0<<endl;
       return 0;
   }

   d/=g;
   k/=g;
   for(i=1;i<=n;i++)
   {
       for(j=0;j<nb[i].size();i++)
       {
           nb[i][j].t/=g;
       }
   }

   for(i=1;i<=n;i++)
   {
       dp[i][0]=1;
   }

   while(clock()/(double)CLOCKS_PER_SEC <= 1.9)
    //for(i=1;i<=100;i++)
   {
       update_DP();
       transfer();
   }

   for(i=1;i<=n;i++)
   {
       for(j=1;j*d<=k;j++)
       {
           ans=(ans+dp[i][j*d])%MOD;
       }
   }

   cout<<ans<<endl;

   return 0;
}


/*
3 3 2 2
1 2 1
2 3 2
3 1 1
*/
